<p-blockUI [target]="pnl" [blocked]="blockedPanel">
    <i class="pi pi-spin pi-spinner" style="font-size: 3rem"></i>
</p-blockUI>
<div class="card">       
    <h5 class="text-blue-500 font-bold"><i class="pi pi-clock text-4xl"></i> จัดการคิว</h5>
    <p-table #pnl #dt 
    [value]="management" 
    scrollDirection="both" 
    [paginator]="true" 
    [rows]="10" 
    [scrollable]="true"
    [showCurrentPageReport]="true" 
    styleClass="mt-3" 
    responsiveLayout="scroll"
    currentPageReportTemplate="Showing {first} to {last} of {totalRecords} entries"
    [rowsPerPageOptions]="[10,25,50]" 
    [globalFilterFields]="['slot_name','customer.customer_name','customer.phone_number','slot_shortdate','period_name','profile.fullname']"
    [rowHover]="true">
    <ng-template pTemplate="caption">
        <div class="flex flex-wrap gap-2 align-items-center justify-content-between">
            <span class="p-input-icon-left w-full sm:w-20rem flex-order-1 sm:flex-order-0">
                <i class="pi pi-search"></i>
                <input pInputText type="text" (input)="onGlobalFilter(dt, $event)" placeholder="ค้นหา.."
                    class="w-full" />
            </span>
        </div>
    </ng-template>
        <ng-template pTemplate="header">
            <tr>
                <th style=" text-align: center;">ลำดับ</th>
                <th>ชื่อ-สกุล</th>
                <th>อายุ (ปี)</th>
                <th>โรคประจำตัว</th>
                <th>เบอร์โทรศัพท์</th>
                <th>บริการ</th>
                <th>เวลา</th>
                <th>สถานะ</th>
                <th></th>

            </tr>
        </ng-template>
        <ng-template pTemplate="header">
            <tr>
                <th>ลำดับ</th>
                <th pSortableColumn="service_type_name">บริการ<p-sortIcon field="service_type_name"></p-sortIcon></th>
                <th pSortableColumn="customer.customer_name">ชื่อ-สกุล<p-sortIcon field="customer_name"></p-sortIcon></th> 
                <th pSortableColumn="phone_number">อายุ (ปี)</th>   
                <th pSortableColumn="chronic">โรคประจำตัว</th>   
                <th pSortableColumn="phone_number">โทรศัพท์</th>   
                <th pSortableColumn="slot_shortdate"  class="white-space-nowrap">วันที่นัด<p-sortIcon field="slot_shortdate"></p-sortIcon></th>
                <th pSortableColumn="period_name">ช่วงเวลา<p-sortIcon field="period_name"></p-sortIcon></th>
                <th pSortableColumn="username">ผู้นัด</th>
                <th pSortableColumn="reserve_shortdate"  class="white-space-nowrap">วันที่จอง<p-sortIcon field="reserve_shortdate"></p-sortIcon></th>
                <th pSortableColumn="reserve_note">หมายเหตุ</th>
                <th>สถานะ</th>
                <th></th>

            </tr>
        </ng-template>
        <ng-template pTemplate="body" let-management let-i="rowIndex">
            <tr>
                <td style=" text-align: center;">{{i+1}}</td>
                <td>{{management.service_type_name}}</td>
                <td>{{management["customer"].customer_name}}</td>
                <td>{{management["customer"].age}}</td>
                <td>{{management["customer"].chronic}}</td>
                <td>{{management["customer"].phone_number}}</td>
                <td>{{management.slot_shortdate}}</td>
                <td>{{management.period_name}}</td>
                <td>{{management["profile"].fullname}}</td>
                <td>{{management.reserve_shortdate}}</td>
                <td>{{management.reserve_note}}</td>
                <td>
                    <p-tag *ngIf="!management.is_confirm && management.status != 'cancel'"  severity="secondary" value="รอยืนยัน" class="h-2rem w-2rem mr-2"></p-tag>
                    <p-tag *ngIf="management.is_confirm && management.status != 'cancel'"  severity="success" value="ยืนยัน" class="h-2rem w-2rem mr-2"></p-tag>
                    <p-tag *ngIf="management.status == 'cancel'" value="ยกเลิก" class="h-2rem w-2rem mr-2" severity="danger"></p-tag>
                
                </td>
                <td>
                    <button *ngIf="!management.is_confirm && management.status != 'cancel'" type="button" pButton pRipple icon="pi pi-check-square" class="h-1rem  mr-2 p-button-success p-button-raised" pTooltip="ยืนยัน" tooltipPosition="bottom" (click)="isconfirm(management.reserve_id,management.is_confirm)"> </button>
                    <button *ngIf="!management.is_confirm && management.status != 'cancel' && !management.reserve_note" type="button" pButton pRipple icon="pi pi-exclamation-triangle" class="h-1rem  mr-2 p-button-secondary p-button-raised" pTooltip="ติดต่อคนไข้ไม่ได้" tooltipPosition="bottom" (click)="loseContact(management.reserve_id)"> </button>
                    <button *ngIf="management.status != 'cancel'" type="button" pButton pRipple icon="pi pi-calendar" class="h-1rem  mr-2 p-button-success p-button-warning" pTooltip="เลื่อนนัด" tooltipPosition="bottom" (click)="displayFormEdit(management)"></button>
                    <button *ngIf="management.status != 'cancel'" type="button" pButton pRipple icon="pi pi-trash" class="h-1rem  mr-2 p-button-success p-button-danger" pTooltip="ยกเลิก" tooltipPosition="bottom" (click)="isCancel(management.reserve_id)"></button>
                </td>
        </ng-template>
    </p-table>
</div>

<p-dialog [(visible)]="displayForm" [breakpoints]="{'960px': '75vw', '640px': '100vw'}" [style]="{width: '30vw',height:'30vw'}">
    <ng-template pTemplate="header">
        <span *ngIf="isAdd"><h5>จองนัดแพทย์</h5></span>
        <span *ngIf="isEdit"><h5>เลื่อนนัด</h5></span>
    </ng-template>
    <ng-template pTemplate="content">
        <div *ngIf="isAdd" class="p-fluid">
            <div class="p-field">
                <label for="service_name">Slot</label>
                <input type="text" id="service_name" [(ngModel)]="managementName" pInputText>
            </div>
        </div>
        <div *ngIf="isEdit" class="p-fluid">
            <div class="p-field">
                <label for="service_name"><h6>เลือกวันนัดใหม่</h6></label>
                <p-dropdown [options]="listSlotByID" [(ngModel)]="selectedDrop" optionLabel="valuename" placeholder="กรุณาเลือกเวลานัด" [filter]="true" [showClear]="true">
                </p-dropdown>
            </div>
        </div>
    </ng-template>
    <ng-template pTemplate="footer">
        <button *ngIf="isAdd" type="button" pButton icon="pi pi-check" class="p-button-raised p-button-success" (click)="save()" label="เพิ่มรายการ"></button>
        <button *ngIf="isEdit" type="button" pButton icon="pi pi-check" class="p-button-raised p-button-success" (click)="update()" label="บันทึกแก้ไข"></button>
    </ng-template>
</p-dialog>
